1 REM --------------------------------------
2 REM -- CleanKey.BAS v1.0
3 REM -- Written by   :  Stuart Respass
4 REM -- Last Updated :  Sat, April 17, 2004
5 REM --------------------------------------


50 REM ----- The "PROGDIR$" variable below should be set to the path where this program is located.
51 REM ----- The folder name(s) should be limited to 8 characters each and should not contain any spaces.

52 PROGDIR$ = "C:\BASIC\PROGRAMS\CleanKey"

53 IF LEN(PROGDIR$) < 3 OR MID$(PROGDIR$, 2, 2) <> ":\" THEN BEEP: PRINT : PRINT : PRINT "The PROGDIR$ variable has not been set correctly!": PRINT : PRINT "Please make corrections in line #52 of this program.": END
54 IF LEN(PROGDIR$) > 3 AND RIGHT$(PROGDIR$, 1) = "\" THEN PROGDIR$ = LEFT$(PROGDIR$, LEN(PROGDIR$) - 1)

55 IF LEN(PROGDIR$) <= 16 THEN APD$ = PROGDIR$: GOTO 60
56 FOR X = LEN(PROGDIR$) TO 1 STEP -1: IF MID$(PROGDIR$, X, 1) = "\" THEN 58
57 NEXT X
58 APD$ = LEFT$(PROGDIR$, 3) + "..." + MID$(PROGDIR$, X)

60 SHELL LEFT$(PROGDIR$, 2)
61 CHDIR PROGDIR$



100 KEY OFF: WIDTH 80, 25: COLOR 11, 0: CLS
110 PRINT : PRINT "CleanKey.BAS is used to compile a NOTFOUND.REG file which can then be used to"
120 PRINT "remove obsolete entries from the following registry key:"
130 PRINT : PRINT "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder\"
140 COLOR 10: PRINT : PRINT : PRINT "This program does not change any files or settings on the system."
150 PRINT "When the program finishes, you can either right-click the NOTFOUND.REG file"
160 PRINT "that is generated and MERGE it, or you can examine it with any text editor."
170 COLOR 11: PRINT : PRINT : PRINT "Output files generated :"
180 PRINT : PRINT "NOTFOUND.REG --- Right-click on this file and choose "; CHR$(34); "Merge"; CHR$(34); " to remove all of"
190 PRINT "                 the obsolete registry entries that were found."
200 PRINT : PRINT "BACKUP.REG   --- This is a backup copy of the original MenuOrder registry key."
210 PRINT "                 If this file is merged, it will undo any changes made by the"
220 PRINT "                 NOTFOUND.REG file.  (ALL of the entries will be restored.)"
230 PRINT : PRINT "The files above are replaced with updated copies each time the program is used."
240 COLOR 0, 7: LOCATE 25, 1: PRINT "Press <ENTER> to begin or <ESC> to quit without doing anything."; STRING$(17, 32);
250 COLOR 7, 0

300 I$ = INKEY$
310 IF I$ = CHR$(13) THEN 1000
320 IF I$ = CHR$(27) THEN 5100
330 GOTO 300



1000 COLOR 11, 0: CLS
1010 PRINT : PRINT "CleanKey.BAS is preparing to run KeyParse.BAT (an embedded support file)."
1020 PRINT "Please wait . . ."

1030 REM ----- THE LINES BELOW ARE BEING PRINTED TO "KeyParse.BAT" (AN EMBEDDED SUPPORT FILE).
1040 OPEN "O", 1, "KeyParse.BAT"
1050 PRINT #1, "@echo off"
1060 PRINT #1, "echo."
1070 PRINT #1, "echo KeyParse.BAT is exporting the BACKUP.REG file and extracting the path info."
1080 PRINT #1, "echo The extracted info will be saved as PathKeys.DAT (a temporary data file)."
1090 PRINT #1, "echo Please wait . . ."
1100 PRINT #1, "start /w regedit /e .\BACKUP.REG HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder"
1110 PRINT #1, "echo.> PathKeys.DAT"
1120 PRINT #1, "echo THIS WAS EXTRACTED AND FILTERED FROM THE BACKUP.REG FILE BY KeyParse.BAT>> PathKeys.DAT"
1130 PRINT #1, "echo NOTE: This file will be easier to read if word wrapping is turned off.>> PathKeys.DAT"
1140 PRINT #1, "find /i "; CHR$(34); "\menuorder\"; CHR$(34); " BACKUP.REG | find /i /v  "; CHR$(34); "\menu"; CHR$(93); CHR$(34);
1150 REM
1160 PRINT #1, " | find /i /v "; CHR$(34); "\f&avorites"; CHR$(34); " | find /i /v "; CHR$(34); "documents"; CHR$(93); CHR$(34);
1170 PRINT #1, " | find /i /v "; CHR$(34); "\&settings"; CHR$(34); " | find /i /v "; CHR$(34); "\&find"; CHR$(34);
1180 PRINT #1, " | find /i /v "; CHR$(34); "\&help"; CHR$(34); " | find /i /v "; CHR$(34); "\&run"; CHR$(34);
1190 PRINT #1, " | find /i /v  "; CHR$(34); "\&log off"; CHR$(34); " | find /i /v  "; CHR$(34); "\sh&ut down"; CHR$(34);
1200 REM
1210 PRINT #1, " | find /i /v "; CHR$(34); "\control panel"; CHR$(34); " | find /i /v "; CHR$(34); "\history"; CHR$(34);
1220 REM
1230 PRINT #1, ">> PathKeys.DAT"
1240 PRINT #1, "echo FINISHED. . . . .  returning to CleanKey.BAS"
1250 CLOSE #1

1260 SHELL "KeyParse.BAT"
1270 KILL "KeyParse.BAT"



2000 OPEN "I", 1, "PathKeys.DAT"
2010 OPEN "O", 2, "PathChk.BAT"
2020 REM ----- THE LINES BELOW ARE BEING PRINTED TO "PathChk.BAT" (A TEMPORARY BATCH FILE).
2030 PRINT #2, "@echo off"
2040 PRINT #2, "echo PathChk.BAT is checking the paths obtained from the PathKeys.DAT file to see"
2050 PRINT #2, "echo if they still exist, and writing the NOTFOUND.REG file."
2060 PRINT #2, "echo Please wait . . ."
2070 PRINT #2, "echo REGEDIT4> NOTFOUND.REG"
2080 PRINT #2, "echo.>> NOTFOUND.REG"
2090 PRINT #2, "echo ; THIS FILE (NOTFOUND.REG) WAS GENERATED BY CleanKey.BAS AT "; TIME$; " ON "; DATE$; ">> NOTFOUND.REG"



2100 PRINT #2, "echo ; AND IS A LIST OF OBSOLETE REGISTRY ENTRIES THAT ARE SAFE TO REMOVE.>> NOTFOUND.REG"
2110 PRINT #2, "echo ;>> NOTFOUND.REG"

2120 PRINT #2, "echo ;>> NOTFOUND.REG"

2130 PRINT #2, "echo ; RIGHT-CLICK ON THIS FILE (located in the "; CHR$(34); PROGDIR$; CHR$(34); " folder)>> NOTFOUND.REG"
2140 PRINT #2, "echo ; AND CHOOSE "; CHR$(34); "Merge"; CHR$(34); " IF YOU WANT TO REMOVE THESE ENTRIES AUTOMATICALLY.>> NOTFOUND.REG"
2150 PRINT #2, "echo ;>> NOTFOUND.REG"
2160 PRINT #2, "echo ;>> NOTFOUND.REG"
2170 PRINT #2, "echo ; NOTE: This file will be easier to read if word wrapping is turned off.>> NOTFOUND.REG"
2180 PRINT #2, "echo ;>> NOTFOUND.REG"
2190 PRINT #2, "echo ;>> NOTFOUND.REG"
2200 PRINT #2, "echo ;>> NOTFOUND.REG"

2210 PRINT #2, "echo ;>> NOTFOUND.REG"

2300 REM ----- THIS INPUT IS BEING RETRIEVED FROM "PathKeys.DAT" (THE TEMPORARY DATA FILE).
2310 IF EOF(1) THEN 2470
2320 LINE INPUT #1, KY$
2330 REM ----- COUNT THE TOTAL ENTRIES CHECKED
2340 IF LEFT$(KY$, 2) = "[H" THEN PK = PK + 1 ELSE 2310

2350 REM ----- THE LINE BELOW REMOVES THE FIRST 80 CHARACTERS OF THE KEY'S NAME (SAVING THE "raw path" KEY INFO).
2360 KY$ = RIGHT$(KY$, LEN(KY$) - 80)
2370 REM ----- THE LINES BELOW HANDLE ALL OF THE "START MENU\PROGRAMS" ENTRIES (including sub-folders), AND ASSIGNS THEM TO THE PA$ VARIABLE.
2380 IF KY$ = "Start Menu\&Programs]" THEN PA$ = CHR$(34) + "Start Menu\Programs" + CHR$(34): GOTO 2440
2390 IF LEFT$(KY$, 21) = "Start Menu\&Programs\" THEN PA$ = CHR$(34) + "Start Menu\Programs\" + RIGHT$(KY$, LEN(KY$) - 21): PA$ = LEFT$(PA$, LEN(PA$) - 1) + CHR$(34): GOTO 2440
2400 REM ----- THE LINE BELOW HANDLES THE REMAINING REGISTRY ENTRIES (FOLDER NAME PATH(S) ON THE START MENU), AND ASSIGNS THEM TO THE PA$ VARIABLE.
2410 REM ----- ATTENTION! ----- FOLDER NAMES WITH HOTKEY SPECIFIERS OR ILLEGAL CHARACTERS WILL NEED TO HAVE BEEN MODIFIED OR FILTERED BEFORE THE NEXT STEP!!
2420 PA$ = CHR$(34) + LEFT$(KY$, LEN(KY$) - 1) + CHR$(34)

2430 REM ----- THE LINES BELOW ARE ALSO BEING PRINTED TO "PathChk.BAT" (THE TEMPORARY BATCH FILE).
2440 PRINT #2, "if not exist %windir%\"; PA$; "\nul echo [-HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\MenuOrder\"; KY$; ">> NOTFOUND.REG"
2450 PRINT #2, "if not exist %windir%\"; PA$; "\nul echo.>> NOTFOUND.REG"
2460 GOTO 2310
2470 PRINT #2, "echo FINISHED. . . . .  returning to CleanKey.BAS"
2480 CLOSE #1, #2
2490 REM ----- FINISHED WRITING "PathChk.BAT" (THE TEMPORARY BATCH FILE)



3000 LOCATE 11, 1: PRINT "CleanKey.BAS has finished processing the data from the PathKeys.DAT file and";
3010 PRINT "has written a temporary batch file (PathChk.BAT) that is about to run now."
3020 PRINT "Please wait . . .": PRINT
3030 SHELL "PathChk.BAT"

3100 REM ----- COUNT THE OBSOLETE ENTRIES DETECTED
3110 OPEN "I", 1, "NOTFOUND.REG"
3120 IF EOF(1) THEN 3160
3130 LINE INPUT #1, X$
3140 IF LEFT$(X$, 2) = "[-" THEN NF = NF + 1
3150 GOTO 3120
3160 CLOSE #1

3200 REM ----- DELETE TEMPORARY FILES
3210 KILL "PathKeys.DAT"
3220 KILL "PathChk.BAT"



4000 COLOR 7, 1: LOCATE 20, 1: PRINT STRING$(80, 223);
4010 COLOR 14
4020 IF NF = 0 THEN 4100 ELSE PRINT "The file NOTFOUND.REG has been saved in the "; APD$; " folder and is ready"; : IF POS(0) > 1 THEN PRINT STRING$(81 - POS(0), 32);
4030 PRINT "to be merged (or examined). The file BACKUP.REG can be used to undo the changes."; : GOTO 4300


4100 PRINT "CleanKey.BAS did not find any obsolete HKCU\.....\MenuOrder\ registry entries.  ";
4110 PRINT "All of the folder paths extracted from the MenuOrder sub-keys are valid.        ";

4120 SHELL "echo REGEDIT4> NOTFOUND.REG"
4130 SHELL "echo.>> NOTFOUND.REG"
4140 SHELL "echo ; THIS FILE (NOTFOUND.REG) WAS GENERATED BY CleanKey.BAS AT " + TIME$ + " ON " + DATE$ + ">> NOTFOUND.REG"
4150 SHELL "echo ;>> NOTFOUND.REG"
4160 SHELL "echo ;>> NOTFOUND.REG"
4170 SHELL "echo ; CleanKey.BAS did not find any obsolete HKCU\.....\MenuOrder\ registry entries.>>NOTFOUND.REG"
4180 SHELL "echo ; All of the folder paths extracted from the MenuOrder sub-keys are valid.>>NOTFOUND.REG"
4190 SHELL "echo ;>>NOTFOUND.REG"
4200 SHELL "echo ; NO ACTION NEEDS TO BE TAKEN AT THIS TIME.>>NOTFOUND.REG"
4210 SHELL "echo ;>>NOTFOUND.REG"
4220 SHELL "echo ; If this file is merged, it will not do anything at all (good or bad).>>NOTFOUND.REG"
4230 SHELL "echo ;>>NOTFOUND.REG"



4300 shell "echo ;>>NOTFOUND.REG"
4310 shell "echo ; ----- SUMMARY:  TOTAL OF KEYS/PATHS CHECKED --"+str$(PK)+"   OBSOLETE KEYS/PATHS --"+str$(NF)+">>NOTFOUND.REG"
4320 shell "echo ;>>NOTFOUND.REG"


4400 COLOR 11: PRINT "Summary:  Total of keys/paths checked --"; PK; "  Obsolete keys/paths --"; NF; STRING$(80 - 64 - (LEN(STR$(PK)) + LEN(STR$(NF))) - 2, 32);
4410 PRINT STRING$(80, 32);


4500 COLOR 0, 7: LOCATE 25, 1
4510 IF NF = 0 THEN PRINT "Press <ESC> to exit this program.  (No further action is required at this time.)"; : GOTO 4530
4520 PRINT "Press <ESC> to open the "; CHR$(34); APD$; CHR$(34); " folder and exit this program."; : IF POS(0) > 1 THEN PRINT STRING$(81 - POS(0), 32);
4530 COLOR 7, 0

4600 I$ = INKEY$
4610 IF I$ = CHR$(27) THEN 5000
4620 GOTO 4600

5000 IF NF = 0 THEN 5100
5005 LOCATE 1, 1
5010 SHELL "if exist .\NOTFOUND.REG %windir%\EXPLORER.EXE /select, .\NOTFOUND.REG"
5020 SHELL "if exist .\NOTFOUND.REG if exist %windir%\notepad.exe %windir%\notepad.exe notfound.reg"

5100 COLOR 7, 0: CLS : SYSTEM
